#include "include:intuition/iobsolete.h"


#define DAYGAD		0
#define CELLGAD 	1
#define XGAD		2
#define YGAD		3
#define LOADGAD		4
#define GOGAD		5
#define STOPGAD		6
#define CLEARGAD	7
#define NAMEGAD		8


SHORT BorderVectors2[] =
{
	0,10,
	23,10,
};

struct Border Border2 =
{
	0,0,
	1,0,COMPLEMENT,
	2,
	BorderVectors2
};

UBYTE DayGadSIBuff[3];
struct StringInfo DayGadSInfo =
{
	DayGadSIBuff,
	NULL,
	0,
	3,
	0,
	0,0,0,0,0,
	0,
	0,
	NULL
};

struct IntuiText DayIText =
{
	1,0,JAM1,
	0,11,
	NULL,
	(UBYTE *)"Day",
	NULL
};

struct Gadget DayGad =
{
	0L,
	4,24,
	24,9,
	NULL,
	RELVERIFY | STRINGCENTER,
	STRGADGET,
	(APTR)&Border2,
	NULL,
	&DayIText,
	NULL,
	(APTR)&DayGadSInfo,
	DAYGAD,
	NULL
};

SHORT BorderVectors4[] =
{
	0,10,
	31,10,
};

struct Border Border4 =
{
	0,0,
	1,0,COMPLEMENT,
	2,
	BorderVectors4
};

UBYTE CellGadSIBuff[4];
struct StringInfo CellGadSInfo =
{
	CellGadSIBuff,
	NULL,
	0,
	4,
	0,
	0,0,0,0,0,
	0,
	0,
	NULL
};

struct IntuiText CellIText =
{
	1,0,JAM1,
	0,11,
	NULL,
	(UBYTE *)"Cell",
	NULL
};

struct Gadget CellGad =
{
	&DayGad,
	130,24,
	24,9,
	NULL,
	RELVERIFY | STRINGCENTER,
	STRGADGET,
	(APTR)&Border4,
	NULL,
	&CellIText,
	NULL,
	(APTR)&CellGadSInfo,
	CELLGAD,
	NULL
};

SHORT BorderVectors3[] =
{
	0,10,
	47,10,
};

struct Border Border3 =
{
	0,0,
	1,0,COMPLEMENT,
	2,
	BorderVectors3
};

UBYTE XGadSIBuff[6];
struct StringInfo XGadSInfo =
{
	XGadSIBuff,
	NULL,
	0,
	6,
	0,
	0,0,0,0,0,
	0,
	0,
	NULL
};

struct IntuiText XIText =
{
	1,0,JAM1,
	16,11,
	NULL,
	(UBYTE *)"X",
	NULL
};

struct Gadget XGad =
{
	&CellGad,
	30,24,
	48,9,
	NULL,
	RELVERIFY | STRINGCENTER,
	STRGADGET,
	(APTR)&Border3,
	NULL,
	&XIText,
	NULL,
	(APTR)&XGadSInfo,
	XGAD,
	NULL
};

UBYTE YGadSIBuff[6];
struct StringInfo YGadSInfo =
{
	YGadSIBuff,
	NULL,
	0,
	6,
	0,
	0,0,0,0,0,
	0,
	0,
	NULL
};

struct IntuiText YIText =
{
	1,0,JAM1,
	16,11,
	NULL,
	(UBYTE *)"Y",
	NULL
};

struct Gadget YGad =
{
	&XGad,
	80,24,
	48,9,
	NULL,
	RELVERIFY | STRINGCENTER,
	STRGADGET,
	(APTR)&Border3,
	NULL,
	&YIText,
	NULL,
	(APTR)&YGadSInfo,
	YGAD,
	NULL
};

struct TextAttr TOPAZ80 =
{
	(STRPTR)"topaz.font",
	TOPAZ_EIGHTY
};

struct NewScreen DragonNewScreen =
{
	0,0,
	640,400,
	1,
	0,1,
	LACE+HIRES,
	CUSTOMSCREEN,
	&TOPAZ80,
	(UBYTE *)"Dragon"
};

SHORT BoxVectors[] =
{
	0,0,
	47,0,
	47,10,
	0,10,
	0,1
};

struct Border Box =
{
	0,0,
	1,0,COMPLEMENT,
	5,
	BoxVectors
};

struct IntuiText LoadText =
{
	1,0,
	JAM2,
	8,2,
	&TOPAZ80,
	(UBYTE *)"Load"
};

struct Gadget LoadGadget =
{
	&YGad,
	4,11,
	48,11,
	GADGHCOMP,
	RELVERIFY,
	BOOLGADGET,
	(APTR)&Box,
	0L,
	&LoadText,
	0L,
	0L,
	LOADGAD
};

struct IntuiText GoText =
{
	1,0,
	JAM2,
	16,2,
	&TOPAZ80,
	(UBYTE *)"Go"
};

struct Gadget GoGadget =
{
	&LoadGadget,
	54,11,
	48,11,
	GADGHCOMP,
	RELVERIFY,
	BOOLGADGET,
	(APTR)&Box,
	0L,
	&GoText,
	0L,
	0L,
	GOGAD
};

struct IntuiText StopText =
{
	1,0,
	JAM2,
	8,2,
	&TOPAZ80,
	(UBYTE *)"Stop"
};

struct Gadget StopGadget =
{
	&GoGadget,
	104,11,
	48,11,
	GADGHCOMP,
	RELVERIFY,
	BOOLGADGET,
	(APTR)&Box,
	0L,
	&StopText,
	0L,
	0L,
	STOPGAD
};

struct IntuiText ClearText =
{
	1,0,
	JAM2,
	4,2,
	&TOPAZ80,
	(UBYTE *)"Clear"
};

struct Gadget ClearGadget =
{
	&StopGadget,
	154,11,
	48,11,
	GADGHCOMP,
	RELVERIFY,
	BOOLGADGET,
	(APTR)&Box,
	0L,
	&ClearText,
	0L,
	0L,
	7
};


SHORT BorderVectors8[] =
{
	0,10,
	198,10,
};

struct Border Border8 =
{
	0,0,
	1,0,COMPLEMENT,
	2,
	BorderVectors8
};

UBYTE NameGadSIBuff[128];
struct StringInfo NameGadSInfo =
{
	NameGadSIBuff,
	NULL,
	0,
	128,
	0,
	0,0,0,0,0,
	0,
	0,
	NULL
};

struct IntuiText NameIText =
{
	1,0,JAM1,
	0,11,
	NULL,
	(UBYTE *)"Dragon file name",
	NULL
};

struct Gadget NameGad =
{
	&ClearGadget,
	4,50,
	198,9,
	NULL,
	RELVERIFY,
	STRGADGET,
	(APTR)&Border8,
	NULL,
	&NameIText,
	NULL,
	(APTR)&NameGadSInfo,
	NAMEGAD,
	NULL
};




struct NewWindow InputNewWin =
{
	400,300,
	206,72,
	0,1,
	GADGETUP+CLOSEWINDOW,
	WINDOWCLOSE+ACTIVATE+NOCAREREFRESH+WINDOWDRAG,
	&NameGad,
	NULL,
	(UBYTE *)"Dragon",
	NULL,
	NULL,
	20,10,
	600,10,
	CUSTOMSCREEN
};

struct NewWindow DragonNewWin =
{
	0,1,
	640,399,
	0,1,
	0L,
	NOCAREREFRESH+BORDERLESS,
	0L,
	NULL,
	0L,
	NULL,
	NULL,
	20,10,
	600,10,
	CUSTOMSCREEN
};
